package main

var k8sWhitelist = map[string]bool{
	"kube_deployment_spec_replicas":               true,
	"kube_deployment_status_replicas_available":   true,
	"kube_deployment_status_replicas_unavailable": true,

	"kube_daemonset_status_desired_number_scheduled": true,
	"kube_daemonset_status_number_available":         true,
	"kube_daemonset_status_number_unavailable":       true,

	"kube_statefulset_replicas":              true,
	"kube_statefulset_status_replicas_ready": true,
}

var dbaasWhitelist = map[string]bool{

	"postgresql_pg_stat_activity_conn_count":       true,
	"postgresql_pg_stat_database_blks_hit":         true,
	"postgresql_pg_stat_database_blks_read":        true,
	"postgresql_pg_stat_database_deadlocks":        true,
	"postgresql_pg_stat_replication_bytes_diff":    true,
	"postgresql_pg_stat_user_tables_idx_scan":      true,
	"postgresql_pg_stat_user_tables_seq_scan":      true,
	"postgresql_pg_stat_user_tables_n_tup_ins":     true,
	"postgresql_pg_stat_user_tables_n_tup_upd":     true,
	"postgresql_pg_stat_user_tables_n_tup_del":     true,
	"postgresql_pg_stat_user_tables_idx_tup_fetch": true,
	"postgresql_pg_stat_user_tables_seq_tup_read":  true,
	"postgresql_pg_stat_database_xact_commit":      true,
	"postgresql_pg_stat_database_xact_rollback":    true,
	"postgresql_database_size_database_size":       true,

	"mongoagent_data_usage_percentage": true,

	"mysql_threads_created":   true,
	"mysql_threads_connected": true,
	"mysql_threads_running":   true,

	"mysql_handler_read_key":      true,
	"mysql_handler_read_first":    true,
	"mysql_handler_read_next":     true,
	"mysql_handler_read_prev":     true,
	"mysql_handler_read_last":     true,
	"mysql_handler_read_rnd":      true,
	"mysql_handler_read_rnd_next": true,

	"mysql_com_select": true,
	"mysql_com_insert": true,
	"mysql_com_update": true,
	"mysql_com_delete": true,

	"mysql_perf_schema_table_io_waits_total_fetch":  true,
	"mysql_perf_schema_table_io_waits_total_insert": true,
	"mysql_perf_schema_table_io_waits_total_update": true,
	"mysql_perf_schema_table_io_waits_total_delete": true,

	"mysql_perf_schema_table_io_waits_seconds_total_fetch":  true,
	"mysql_perf_schema_table_io_waits_seconds_total_insert": true,
	"mysql_perf_schema_table_io_waits_seconds_total_update": true,
	"mysql_perf_schema_table_io_waits_seconds_total_delete": true,

	"mysql_innodb_buffer_pool_reads":         true,
	"mysql_innodb_buffer_pool_read_requests": true,
	"mysql_innodb_data_written":              true,

	"mysql_questions":                   true,
	"mysql_slow_queries":                true,
	"mysql_global_connection_memory":    true,
	"mysql_slave_seconds_behind_master": true,

	"redis_total_connections_received": true,
	"redis_rejected_connections":       true,
	"redis_evicted_keys":               true,
	"redis_keyspace_hits":              true,
	"redis_keyspace_keys":              true,
	"redis_keyspace_misses":            true,
	"redis_instantaneous_ops_per_sec":  true,
	"redis_used_memory_rss":            true,
	"redis_used_memory":                true,
	"redis_connected_slaves":           true,
	"redis_clients":                    true,
	"redis_total_commands_processed":   true,
	"redis_uptime":                     true,
	"redis_replication_lag":            true,
	"redis_replication_offset":         true,

	"valkey_total_connections_received": true,
	"valkey_rejected_connections":       true,
	"valkey_evicted_keys":               true,
	"valkey_keyspace_hits":              true,
	"valkey_keyspace_keys":              true,
	"valkey_keyspace_misses":            true,
	"valkey_instantaneous_ops_per_sec":  true,
	"valkey_used_memory_rss":            true,
	"valkey_used_memory":                true,
	"valkey_connected_slaves":           true,
	"valkey_clients":                    true,
	"valkey_total_commands_processed":   true,
	"valkey_uptime":                     true,
	"valkey_replication_lag":            true,
	"valkey_replication_offset":         true,

	"kafka_log_Log_Size_Value": true,

	"kafka_server_BrokerTopicMetrics_BytesInPerSec_Count":                    true,
	"kafka_server_BrokerTopicMetrics_BytesOutPerSec_Count":                   true,
	"kafka_server_BrokerTopicMetrics_MessagesInPerSec_Count":                 true,
	"kafka_server_BrokerTopicMetrics_ReplicationBytesInPerSec_Count":         true,
	"kafka_server_BrokerTopicMetrics_ReplicationBytesOutPerSec_Count":        true,
	"kafka_server_KafkaServer_linux_disk_read_bytes_Value":                   true,
	"kafka_server_KafkaServer_linux_disk_write_bytes_Value":                  true,
	"kafka_server_ReplicaManager_UnderReplicatedPartitions_Value":            true,
	"kafka_server_ReplicaManager_OfflineReplicaCount_Value":                  true,
	"kafka_server_ReplicaManager_UnderMinIsrPartitionCount_Value":            true,
	"kafka_server_ReplicaManager_IsrExpandsPerSec_Count":                     true,
	"kafka_server_ReplicaManager_IsrShrinksPerSec_Count":                     true,
	"kafka_server_group_coordinator_metrics_group_completed_rebalance_count": true,
	"kafka_server_group_coordinator_metrics_offset_commit_count":             true,

	"kafka_network_RequestMetrics_RequestsPerSec_Count":    true,
	"kafka_network_RequestChannel_ResponseQueueSize_Value": true,
	"kafka_network_RequestMetrics_TotalTimeMs_Count":       true,

	"kafka_controller_KafkaController_ActiveBrokerCount_Value":              true,
	"kafka_controller_KafkaController_ActiveControllerCount_Value":          true,
	"kafka_controller_KafkaController_OfflinePartitionsCount_Value":         true,
	"kafka_controller_KafkaController_PreferredReplicaImbalanceCount_Value": true,
	"kafka_controller_ControllerStats_LeaderElectionRateAndTimeMs_Count":    true,

	"opensearch_cluster_health_number_of_nodes":       true,
	"opensearch_cluster_health_active_shards":         true,
	"opensearch_cluster_health_relocating_shards":     true,
	"opensearch_cluster_health_unassigned_shards":     true,
	"opensearch_cluster_health_active_primary_shards": true,

	"opensearch_clusterstats_indices_count":               true,
	"opensearch_clusterstats_indices_store_size_in_bytes": true,
	"opensearch_clusterstats_indices_docs_count":          true,
	"opensearch_clusterstats_indices_docs_deleted":        true,

	"opensearch_indices_search_scroll_total":           true,
	"opensearch_indices_search_scroll_time_in_millis":  true,
	"opensearch_indices_search_query_total":            true,
	"opensearch_indices_search_query_time_in_millis":   true,
	"opensearch_indices_indexing_index_total":          true,
	"opensearch_indices_indexing_index_time_in_millis": true,
	"opensearch_indices_merges_total":                  true,
	"opensearch_indices_merges_total_time_in_millis":   true,
	"opensearch_indices_refresh_total":                 true,
	"opensearch_indices_refresh_total_time_in_millis":  true,
	"opensearch_indices_search_fetch_total":            true,
	"opensearch_indices_search_fetch_time_in_millis":   true,
	"opensearch_indices_search_suggest_total":          true,
	"opensearch_indices_search_suggest_time_in_millis": true,
	"opensearch_indices_query_cache_cache_size":        true,
	"opensearch_indices_query_cache_hit_count":         true,
	"opensearch_indices_query_cache_miss_count":        true,
	"opensearch_indices_query_cache_evictions":         true,

	"opensearch_jvm_mem_heap_used_in_bytes": true,
	"opensearch_jvm_threads_count":          true,

	"opensearch_http_total_opened": true,
}

var gpuWhitelist = map[string]bool{
	// GPU Utilization
	"amd_gpu_prof_gui_util_percent":      true,
	"amd_gpu_prof_valu_pipe_issue_util":  true,
	"amd_gpu_prof_tensor_active_percent": true,
	"amd_gpu_prof_occupancy_percent":     true,
	"amd_gpu_prof_fetch_size":            true,
	"amd_gpu_prof_write_size":            true,

	// GPU VRAM usage
	"amd_gpu_used_vram":  true,
	"amd_gpu_total_vram": true,
	"amd_gpu_free_vram":  true,

	// XGMI Bandwidth
	"amd_xgmi_neighbor_0_tx_throughput": true,
	"amd_xgmi_neighbor_1_tx_throughput": true,
	"amd_xgmi_neighbor_2_tx_throughput": true,
	"amd_xgmi_neighbor_3_tx_throughput": true,
	"amd_xgmi_neighbor_4_tx_throughput": true,
	"amd_xgmi_neighbor_5_tx_throughput": true,
	"amd_xgmi_neighbor_6_tx_throughput": true,
	"amd_xgmi_neighbor_7_tx_throughput": true,

	"amd_xgmi_neighbor_0_response_tx": true,
	"amd_xgmi_neighbor_1_response_tx": true,
	"amd_xgmi_neighbor_2_response_tx": true,
	"amd_xgmi_neighbor_3_response_tx": true,
	"amd_xgmi_neighbor_4_response_tx": true,
	"amd_xgmi_neighbor_5_response_tx": true,
	"amd_xgmi_neighbor_6_response_tx": true,
	"amd_xgmi_neighbor_7_response_tx": true,

	"amd_xgmi_neighbor_0_request_tx": true,
	"amd_xgmi_neighbor_1_request_tx": true,
	"amd_xgmi_neighbor_2_request_tx": true,
	"amd_xgmi_neighbor_3_request_tx": true,
	"amd_xgmi_neighbor_4_request_tx": true,
	"amd_xgmi_neighbor_5_request_tx": true,
	"amd_xgmi_neighbor_6_request_tx": true,
	"amd_xgmi_neighbor_7_request_tx": true,

	// PCIe bandwidth
	"amd_pcie_bandwidth": true,

	"amd_gpu_ecc_uncorrect_total":                         true,
	"amd_pcie_replay_count":                               true,
	"amd_pcie_recovery_count":                             true,
	"amd_pcie_replay_rollover_count":                      true,
	"amd_pcie_max_speed":                                  true,
	"amd_pcie_speed":                                      true,
	"amd_gpu_prof_cpf_cpf_stat_stall":                     true,
	"amd_gpu_clock":                                       true,
	"amd_gpu_violation_proc_hot_residency_accumulated":    true,
	"amd_gpu_violation_soc_thermal_residency_accumulated": true,
	"amd_gpu_violation_ppt_residency_accumulated":         true,
	"amd_gpu_violation_hbm_thermal_residency_accumulated": true,
	"amd_gpu_violation_vr_thermal_tracking_accumulated":   true,
	"amd_gpu_junction_temperature":                        true,
	"amd_gpu_power_usage":                                 true,
	"amd_gpu_memory_temperature":                          true,
}
